import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
var _excluded = ["events"];
import _regeneratorRuntime from "@babel/runtime/regenerator";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import createEventStoreLite from '@resolve-js/eventstore-lite';
import { prepareEvents } from './prepare-events';
import { ambiguousEventsTimeErrorMessage } from '../constants';
export var validateEvents = function validateEvents(events) {
  var stampedCount = events.filter(function (event) {
    return event.timestamp != null;
  }).length;

  if (stampedCount !== events.length && stampedCount > 0) {
    throw Error(ambiguousEventsTimeErrorMessage);
  }
};
export var getEventStore = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(events, context) {
    var preparedEvents, eventByAggregateIdVersion, eventIndex, _preparedEvents$event, aggregateId, aggregateVersion, event, eventStoreAdapter, _iterator, _step, _event;

    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            validateEvents(events);
            preparedEvents = prepareEvents(events, context);
            eventByAggregateIdVersion = new Map();

            for (eventIndex = 0; eventIndex < events.length; eventIndex++) {
              _preparedEvents$event = preparedEvents[eventIndex], aggregateId = _preparedEvents$event.aggregateId, aggregateVersion = _preparedEvents$event.aggregateVersion;
              event = events[eventIndex];

              if (event != null) {
                eventByAggregateIdVersion.set(aggregateId + ":" + aggregateVersion, event);
              }
            }

            eventStoreAdapter = createEventStoreLite({
              databaseFile: ':memory:'
            });
            _context2.next = 7;
            return eventStoreAdapter.init();

          case 7:
            _iterator = _createForOfIteratorHelperLoose(preparedEvents);

          case 8:
            if ((_step = _iterator()).done) {
              _context2.next = 14;
              break;
            }

            _event = _step.value;
            _context2.next = 12;
            return eventStoreAdapter.saveEvent(_event);

          case 12:
            _context2.next = 8;
            break;

          case 14:
            return _context2.abrupt("return", _extends({}, eventStoreAdapter, {
              loadEvents: function () {
                var _loadEvents = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                  var _yield$eventStoreAdap,
                      originalEvents,
                      other,
                      eventsFromEventStore,
                      timestampIndex,
                      _eventByAggregateIdVe,
                      _eventByAggregateIdVe2,
                      eventFromEventStore,
                      _args = arguments;

                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return eventStoreAdapter.loadEvents.apply(eventStoreAdapter, _args);

                        case 2:
                          _yield$eventStoreAdap = _context.sent;
                          originalEvents = _yield$eventStoreAdap.events;
                          other = _objectWithoutPropertiesLoose(_yield$eventStoreAdap, _excluded);
                          eventsFromEventStore = JSON.parse(JSON.stringify(originalEvents));

                          for (timestampIndex = 0; timestampIndex < eventsFromEventStore.length; timestampIndex++) {
                            eventFromEventStore = eventsFromEventStore[timestampIndex];
                            eventFromEventStore.timestamp = (_eventByAggregateIdVe = (_eventByAggregateIdVe2 = eventByAggregateIdVersion.get(eventFromEventStore.aggregateId + ":" + eventFromEventStore.aggregateVersion)) == null ? void 0 : _eventByAggregateIdVe2.timestamp) != null ? _eventByAggregateIdVe : timestampIndex;
                          }

                          return _context.abrupt("return", _extends({}, other, {
                            events: eventsFromEventStore
                          }));

                        case 8:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                function loadEvents() {
                  return _loadEvents.apply(this, arguments);
                }

                return loadEvents;
              }()
            }));

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getEventStore(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();
//# sourceMappingURL=get-event-store.js.map