"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.shouldProduceEvent = void 0;

var _lodash = _interopRequireDefault(require("lodash.isequal"));

var _format = require("../../utils/format");

var shouldProduceEvent = function shouldProduceEvent(context, expectedEvent) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be assigned if the test was executed.");
  }

  if (environment.getAssertion() != null) {
    throw Error("The test assertion already assigned.");
  }

  environment.setAssertion(function (resolve, reject, result, error) {
    if (error) {
      return reject(new Error("expected an event, but received an error " + error));
    }

    if (!(0, _lodash["default"])(result, expectedEvent)) {
      return reject(new Error("shouldProduceEvent assertion failed:\n " + (0, _format.stringifyDiff)(expectedEvent, result)));
    }

    return resolve(result);
  });
  return environment.promise;
};

exports.shouldProduceEvent = shouldProduceEvent;
//# sourceMappingURL=should-produce-event.js.map